<?

/*

libPopupMenu.php

DESCRIPTION

	MenuPopup - PHP class that generates a DHTML Popup Menu

SYNOPSIS

	$pop = new PopupMenu( "mypopup" );	
	$pop->addItem( "Altavista", "http://www.altavista.com", "_new" );
	$pop->addItem( "Go Yahoo!", "http://www.yahoo.com", "_new" );
	$pop->addSeparator();
	$pop->addItem( "Send me a mail", "mailto:lwest@free.fr?subject=libPopupMenu" );
	$pop->addItem( "Page source", "javascript:document.location='view-source:'+document.location" );

	$pop->set( "border", 0 );
	$pop->set( "width", 80 );
	$pop->set( "bgcolor", "white" );
	$pop->set( "margin", 3 );
	
	// output CSS then HTML and JS code of the popup
	$pop->DisplayCss(); 
	$pop->Display(); 
	
	?><a href="#" onMouseOver="<?echo  $pop->jsCall(); ?>">My Menu</a><?

STATUS

	Version      0.4
	Licence      Free of use
	Author       Leo West <lwest@free.fr>
	Created      Sun Oct 01 23:12:04 UTC 2000
	Modified     Thu Oct 26 11:18:47 UTC 2000
		
*/

class PopupMenu
{

	function PopupMenu( $menuid )
	{
		$this->id = $menuid;
		// default properties values
		$this->width= 100;
		$this->height= 100;
		$this->bgcolor= "#C0C0C0";
		$this->color= "blue";
		$this->align = "left";
		$this->margin = 2;
		$this->border = 1;
		$this->fontFamily = "Helvetica,Arial";
		$this->fontSize = "11px";
		$this->menuItemFormat = '<a href="%s" target="%s" onClick="PopupHide(\'%s\')">%s</a><br>';
	}

	function addSeparator()
	{
		$this->separators[count($this->items)] = 1;
	}
	
	function addItem( $caption, $url, $target="" )
	{
		if( $target== "" ) $target = "_self";
		
		$itm = array( 'caption' => $caption, 'url'=> $url, 'target'=> $target );
		$this->items[] = $itm;
	}
	
	function set( $property, $value ) 
	{
		$this->$property = $value;
	}
	
	function Display()
	{
		
		$this->displayJsCode();
		
?>
<layer name="<?echo $this->id?>" onMouseOut="PopupHide('<?echo $this->id?>')" visibility="hidden">
<table 
 cellspacing="0"
 bgcolor="<?echo $this->bgcolor?>"
 cellpadding="<?echo $this->margin?>"
 border="<?echo $this->border?>"
 width="<?echo $this->width?>" height="<?$this->height?>">
<tr>
<td 
 align="<?echo  $this->align ?>"
 bgcolor="<?echo  $this->bgcolor ?>">
<?
	$fmtItem = $this->menuItemFormat; 
	
	for( $i=0; $i< count($this->items) ; $i++ )
	{
		if( $this->separators[$i] )
			echo "<hr noshade size=0>";
			
		$itm = $this->items[$i];
		printf( $fmtItem, $itm[url], $itm[target], $this->id, $itm[caption] );
		echo "\n";
	}
	
?>
	</td></tr>
</table>
</layer>
<?
	} // Display()


	function jsCall()
	{
		return "PopupShow( '$this->id', this );return false";
	}


	function displayJsCode()
	{

?>
<script language="javascript" type="text/javascript">
<!--

function PopupShow( popupID, oLink )
{
	xpos = oLink.x;
	ypos = oLink.y;
	
	if( document.layers ) {
		lay = document.layers[popupID];
		lay.moveTo( xpos + 2, ypos + 2 );
		lay.visibility = 'show';
	}
}

function PopupHide( popupID )
{
	if( document.layers ) {
		document.layers[popupID].visibility= 'hide';
	}
}
// -->
</script>
<?	

	} // displayJsCode()

	// sample stylesheet - to be customized via overload
	function displayCSS()
	{
?>
<style type="text/css">
	A{ 
		font: <?echo $this->fontSize?> <?echo $this->fontFamily?>; 
		text-decoration: none;
		color: <?echo  $this->color ?>;
	}
</style>
<?
	}
	
} // class




?>
